load("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2023 01 10 keras auto/.RData")
setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2023 01 10 Keras auto")

# Disable GPU                                                                   
Sys.setenv("CUDA_VISIBLE_DEVICES" = -1)   

# Then load keras
library(keras)                                                                  
use_backend("tensorflow")

# autoencoder in keras
suppressPackageStartupMessages(library(keras))

# set training data
x_train <- as.matrix(train_data_num_2)
x_test<-as.matrix(test_data_num_2)

# set model
model <- keras_model_sequential()
model %>%
  layer_dense(units = 5, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 2, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 5, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model)

# compile model
model %>% compile(
  loss = "mean_squared_error", 
  optimizer = "adam" 
)#optimizer_adam(lr = 0.001) ## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

set.seed(123)
# fit model
model %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  verbose = 2 #training process showing
)

model %>% save_model_hdf5("model_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model, x_train, x_train)
mse.ae2
loss 
0.009847568 

# extract the bottleneck layer
intermediate_layer_model <- keras_model(inputs = model$input, outputs = get_layer(model, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
train3<-as.data.frame(intermediate_output)
Test_intermediate_output <- predict(intermediate_layer_model, x_test)
test3<-as.data.frame(Test_intermediate_output)


plot(train3$V1, train3$V2, pch=18, xlab='1 bottleneck', col=train_data_num$TARGET, ylab='2 bottleneck', main = 'TRAIN')
plot(test3$V1, test3$V2, pch=18, xlab='1 bottleneck', col=test_data_num$TARGET, ylab='2 bottleneck', main = 'Test')


##############################
suppressPackageStartupMessages(library(keras))


# set model
model100 <- keras_model_sequential()
model100 %>%
  layer_dense(units = 100, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model100)

# compile model
model100 %>% compile(
  loss = "mean_squared_error", 
  optimizer = "adam"
)

set.seed(123)
# fit model
model100 %>% fit(
  x = x_train, 
  y = x_train, 
  epochs = 100,
  verbose = 2 #training process showing
)

model100 %>% save_model_hdf5("model_autocoder100.h5")

# evaluate the performance of the model
 
mse.ae2 <- evaluate(model100, x_train, x_train)
mse.ae2
0.0007728932 

# extract the bottleneck layer
intermediate_layer_model100 <- keras_model(inputs = model100$input, outputs = get_layer(model100, "dense_1")$output)
intermediate_output <- predict(intermediate_layer_model100, x_train)
train3<-as.data.frame(intermediate_output)
Test_intermediate_output <- predict(intermediate_layer_model100, x_test)
test3<-as.data.frame(Test_intermediate_output)


plot(train3$V1, train3$V2, pch=18, xlab='1 bottleneck', col=train_data_num$TARGET, ylab='2 bottleneck', main = 'TRAIN')
plot(test3$V1, test3$V2, pch=18, xlab='1 bottleneck', col=test_data_num$TARGET, ylab='2 bottleneck', main = 'Test')


############
suppressPackageStartupMessages(library(keras))


# set model
model50 <- keras_model_sequential()
model50 %>%
  layer_dense(units = 50, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model50)

# compile model
model50 %>% compile(
  loss = "mean_squared_error", 
  optimizer = "adam"
)

set.seed(123)
# fit model
model50 %>% fit(
  x = x_train, 
  y = x_train, 
  epochs = 100,
  verbose = 2 #training process showing
)

model50 %>% save_model_hdf5("model_autocoder100.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model50, x_train, x_train)
mse.ae2
0.001749635

suppressPackageStartupMessages(library(keras))


# set model
model150 <- keras_model_sequential()
model150 %>%
  layer_dense(units = 150, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model150)

# compile model
model150 %>% compile(
  loss = "mean_squared_error", 
  optimizer = "adam"
)

set.seed(123)
# fit model
model150 %>% fit(
  x = x_train, 
  y = x_train, 
  epochs = 50,
  verbose = 2 #training process showing
)

model150 %>% save_model_hdf5("model_autocoder100.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model150, x_train, x_train)
mse.ae2
0.001749635


########
# set model
model5_1_5 <- keras_model_sequential()
model5_1_5 %>%
  layer_dense(units = 500, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 100, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 500, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model5_1_5)

# compile model
model5_1_5 %>% compile(
  loss = "mean_squared_error", 
  optimizer = "adam"
)

set.seed(123)
# fit model
model5_1_5 %>% fit(
  x = x_train, 
  y = x_train, 
  epochs = 50,
  verbose = 2 #training process showing
)

model5_1_5 %>% save_model_hdf5("model_autocoder5_1_5.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model5_1_5, x_train, x_train)
mse.ae2

##############################
# set model
model5_2_1_2_5 <- keras_model_sequential()
model5_2_1_2_5 %>%
  layer_dense(units = 500, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 250, activation = "tanh") %>%
  layer_dense(units = 100, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 250, activation = "tanh") %>%
  layer_dense(units = 500, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model5_2_1_2_5)

# compile model
model5_2_1_2_5 %>% compile(
  loss = "mean_squared_error", 
  optimizer = "adam"
)

set.seed(123)
# fit model
model5_2_1_2_5 %>% fit(
  x = x_train, 
  y = x_train, 
  epochs = 50,
  verbose = 2 #training process showing
)

model5_2_1_2_5 %>% save_model_hdf5("model_autocoder5_2_1_2_5.h5")

# evaluate the performance of the model
mse.ae5_2_1 <- evaluate(model5_2_1_2_5, x_train, x_train)
mse.ae5_2_1

##############################
# set model
model7_5_2_1_2_5_7 <- keras_model_sequential()
model7_5_2_1_2_5_7 %>%
  layer_dense(units = 750, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 500, activation = "tanh") %>%
  layer_dense(units = 250, activation = "tanh") %>%
  layer_dense(units = 100, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 250, activation = "tanh") %>%
  layer_dense(units = 500, activation = "tanh") %>%
  layer_dense(units = 750, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model7_5_2_1_2_5_7)

# compile model
model7_5_2_1_2_5_7 %>% compile(
  loss = "mean_squared_error", 
  optimizer = "adam"
)

set.seed(123)
# fit model
model7_5_2_1_2_5_7 %>% fit(
  x = x_train, 
  y = x_train, 
  epochs = 50,
  verbose = 2 #training process showing
)

model7_5_2_1_2_5_7 %>% save_model_hdf5("model_autocoder7_5_2_1_2_5_7.h5")

# evaluate the performance of the model
mse.ae7_5_2_1 <- evaluate(model7_5_2_1_2_5_7, x_train, x_train)
mse.ae7_5_2_1

##############################
# set model
model8_4_2_1 <- keras_model_sequential()
model8_4_2_1 %>%
  layer_dense(units = 800, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 400, activation = "tanh") %>%
  layer_dense(units = 200, activation = "tanh") %>%
  layer_dense(units = 100, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 200, activation = "tanh") %>%
  layer_dense(units = 400, activation = "tanh") %>%
  layer_dense(units = 800, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model8_4_2_1)

# compile model
model8_4_2_1 %>% compile(
  loss = "mean_squared_error", 
  optimizer = "adam"
)

set.seed(123)
# fit model
model8_4_2_1 %>% fit(
  x = x_train, 
  y = x_train, 
  epochs = 50,
  verbose = 2 #training process showing
)

model8_4_2_1 %>% save_model_hdf5("model_autocoder8_4_2_1.h5")

# evaluate the performance of the model
mse.ae8_4_2_1 <- evaluate(model8_4_2_1, x_train, x_train)
mse.ae8_4_2_1


##############################
# set model
model6_3_1 <- keras_model_sequential()
model6_3_1 %>%
  layer_dense(units = 600, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 300, activation = "tanh") %>%
  layer_dense(units = 100, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 300, activation = "tanh") %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 600, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model6_3_1)

# compile model
model6_3_1 %>% compile(
  loss = "mean_squared_error", 
  optimizer = "adam"
)

set.seed(123)
# fit model
model6_3_1 %>% fit(
  x = x_train, 
  y = x_train, 
  epochs = 50,
  verbose = 2 #training process showing
)

model6_3_1 %>% save_model_hdf5("model_autocoder6_3_1.h5")

# evaluate the performance of the model
mse.ae6_3_1 <- evaluate(model6_3_1, x_train, x_train)
mse.ae6_3_1


##############################
# set model
model87654321 <- keras_model_sequential()
model87654321 %>%
  layer_dense(units = 888, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 777, activation = "tanh") %>%
  layer_dense(units = 666, activation = "tanh") %>%
  layer_dense(units = 555, activation = "tanh") %>%
  layer_dense(units = 444, activation = "tanh") %>%
  layer_dense(units = 333, activation = "tanh") %>%
  layer_dense(units = 222, activation = "tanh") %>%
  layer_dense(units = 100, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 222, activation = "tanh") %>%
  layer_dense(units = 333, activation = "tanh") %>%
  layer_dense(units = 444, activation = "tanh") %>%
  layer_dense(units = 555, activation = "tanh") %>%
  layer_dense(units = 666, activation = "tanh") %>%
  layer_dense(units = 777, activation = "tanh") %>%
  layer_dense(units = 888, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model87654321)

# compile model
model87654321 %>% compile(
  loss = "mean_squared_error", 
  optimizer = "adam"
)

set.seed(123)
# fit model
model87654321 %>% fit(
  x = x_train, 
  y = x_train, 
  epochs = 50,
  verbose = 2 #training process showing
)

model87654321 %>% save_model_hdf5("model_autocoder87654321.h5")

# evaluate the performance of the model
mse.ae87654321 <- evaluate(model87654321, x_train, x_train)
mse.ae87654321

##############################
# set model
model6321 <- keras_model_sequential()
model6321 %>%
  layer_dense(units = 618, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 382, activation = "tanh") %>%
  layer_dense(units = 236, activation = "tanh") %>%
  layer_dense(units = 146, activation = "tanh") %>%
  layer_dense(units = 100, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 146, activation = "tanh") %>%
  layer_dense(units = 236, activation = "tanh") %>%
  layer_dense(units = 382, activation = "tanh") %>%
  layer_dense(units = 618, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model6321)

# compile model
model6321 %>% compile(
  loss = "mean_squared_error", 
  optimizer = "adam"
)

set.seed(123)
# fit model
model6321 %>% fit(
  x = x_train, 
  y = x_train, 
  epochs = 50,
  verbose = 2 #training process showing
)

model6321 %>% save_model_hdf5("model_autocoder6321.h5")

# evaluate the performance of the model
mse.ae6321 <- evaluate(model6321, x_train, x_train)
mse.ae6321

##############################
# set model
model310 <- keras_model_sequential()
model310 %>%
  layer_dense(units = 318, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 101, activation = "tanh") %>%
  layer_dense(units = 32, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 101, activation = "tanh") %>%
  layer_dense(units = 318, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model310)

# compile model
model310 %>% compile(
  loss = "mean_squared_error", 
  optimizer = "adam"
)

set.seed(123)
# fit model
model310 %>% fit(
  x = x_train, 
  y = x_train, 
  epochs = 50,
  verbose = 2 #training process showing
)

model310 %>% save_model_hdf5("model_autocoder310.h5")

# evaluate the performance of the model
mse.ae310 <- evaluate(model310, x_train, x_train)
mse.ae310