load("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2023 01 10 H20/.RData")
setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2023 01 10 H20")

library(h2o)
library(dplyr)
library(arrow)
library(readr)
library(magrittr)
library(stringi)

#Konvertavimas i h2o dataframe:
train_data_num_2<-train_data_num[,-c(1)]
test_data_num_2<-test_data_num[,-c(1)]

h2o.init()
train_hex <- as.h2o(train_data_num_2)
test_hex<-as.h2o(test_data_num_2)

#https://bradleyboehmke.github.io/HOML/autoencoders.html

# Train an autoencoder
ae1 <- h2o.deeplearning(
  x = seq_along(train_hex),
  training_frame = train_hex,
  autoencoder = TRUE,
  hidden = 100,
  activation = 'Tanh',
  sparse = TRUE
)


ae1_codings <- h2o.deepfeatures(ae1, features, layer = 1)
ae1_codings




hyper_grid <- list(hidden = list(
  c(50),
  c(100), 
  c(300, 100, 300),
  c(100, 50, 100),
  c(250, 100, 50, 100, 250)
))

# Execute grid search
ae_grid <- h2o.grid(
  algorithm = 'deeplearning',
  x = seq_along(features),
  training_frame = features,
  grid_id = 'autoencoder_grid',
  autoencoder = TRUE,
  activation = 'Tanh',
  hyper_params = hyper_grid,
  sparse = TRUE,
  ignore_const_cols = FALSE,
  seed = 123
)

h2o.getGrid('autoencoder_grid', sort_by = 'mse', decreasing = FALSE)
best_model_id <- ae_grid@model_ids[[1]]
best_model <- h2o.getModel(best_model_id)
test_ae1_codings <- predict(best_model, as.h2o(sampled_digits))


score_train <- h2o.anomaly(best_model, train_hex)
###########################RIMANTES

#Kintamieji naudojami modelyje:
featureNames = colnames(train_hex)[1:ncol.H2OFrame(train_hex)]

#Modelio pavadinimas:
modelName <- paste0(filter_klientas, "_", filter_beat_name)
modelName <- gsub(" ", "_", modelName, fixed=TRUE)
modelName <- gsub("-", "_", modelName, fixed=TRUE)
modelName <- stri_trans_general(modelName, "latin-ascii")


#Grid search:

n_col <- h2o.ncol(train_hex)
h1 <- c(100)
h2 <- c(round(n_col*0.5), 100, round(n_col*0.5))
h3 <- c(round(n_col*0.3), 100, round(n_col*0.3))
h4 <- c(round(n_col*0.7), round(n_col*0.5), 100, round(n_col*0.5), round(n_col*0.7))

hyper_params <- list(
  activation = c("Rectifier", "Tanh", "RectifierWithDropout", "TanhWithDropout"), 
  hidden = list(h1, h2, h3,h4),
  epochs = c(25, 50, 100),
  l1 = c(0, 0.00001, 0.0001), 
  l2 = c(0, 0.00001, 0.0001),
  rate = c(0, 0.01, 0.005, 0.001),
  input_dropout_ratio = c(0, 0.1, 0.2)
)

search_criteria <- list(strategy = "RandomDiscrete", 
                        max_models = 100,
                        max_runtime_secs = 900,
                        stopping_tolerance = 0.001,
                        stopping_rounds = 15,
                        seed = 42)

anomaly_model_grid <- h2o.grid(algorithm = "deeplearning",
                               grid_id = modelName,
                               x = featureNames, 
                               training_frame = train_hex,
                               autoencoder = TRUE,
                               sparse = TRUE,
                               hyper_params = hyper_params,
                               search_criteria = search_criteria,
                               seed = 42)

grid <- h2o.getGrid(modelName, sort_by = 'mse', decreasing = FALSE)
best_model <- h2o.getModel(grid@model_ids[[1]])
h2o.saveModel(best_model, save_dir, force = TRUE)

score_train <- h2o.anomaly(best_model, train_hex)

#h2o.anomaly(best_model, test_hex, per_feature = TRUE)

train_hex

return_train <- h2o.cbind(train_hex[1], score_train)

return_list <- list(return_train)



##############
#### AUTOENKODERIO PARAMETRAI######
#overwrite_with_best_model: Specify whether to overwrite the final model with the best model found during 
#training, based on the option specified for stopping_metric. This option is enabled by default.

#standardize: If enabled, automatically standardize the data (mean 0, variance 1). If disabled, the user must 
#provide properly scaled input data. This option defaults to true.

#https://www.sciencedirect.com/science/article/pii/S2666143821000119
#As activation functions, we used the hyperbolic tangent (tanh) and rectified linear unit (ReLu) according to 
#how the input data are normalized. They are scaled to be between 0 and 1 for tanh and normalized to have mean 
#of 0 with a standard deviation of 1 for ReLu, respectively.

#activation: Specify the activation function (Tanh, Tanh with dropout, Rectifier, Rectifier with dropout, Maxout,
#                                             Maxout with dropout). This option defaults to Rectifier.

#Note: Maxout is not supported when autoencoder is enabled.

#hidden: Specify the hidden layer sizes (e.g., 100,100). The value must be positive. This option defaults to 
#(200,200).

#epochs: Specify the number of times to iterate (stream) the dataset. The value can be a fraction. This option 
#defaults to 10.

#seed: Specify the random number generator (RNG) seed for algorithm components dependent on randomization. The 
#seed is consistent for each H2O instance so that you can create models with the same starting conditions in 
#alternative configurations. This option defaults to -1 (time-based random number).

#rate: (Applicable only if adaptive_rate is disabled) Specify the learning rate. Higher values result in a less 
#stable model, while lower values lead to slower convergence. This option defaults to 0.005.


#hidden_dropout_ratios: (Applicable only if the activation type is TanhWithDropout, RectifierWithDropout, or 
#                        MaxoutWithDropout) Specify the hidden layer dropout ratio to improve generalization. 
#Specify one value per hidden layer. The range is >= 0 to <1, and the default is 0.5.

#l1: Specify the L1 regularization to add stability and improve generalization; sets the value of many weights 
#to 0 (default).

#l2: Specify the L2 regularization to add stability and improve generalization; sets the value of many weights 
#to smaller values. Defaults to 0.

#loss: Specify the loss function. The options are Automatic, CrossEntropy, Quadratic, Huber, or Absolute and 
#the default value is Automatic. This option defaults to Automatic.
#Use Absolute, Quadratic, or Huber for regression
#Use Absolute, Quadratic, Huber, or CrossEntropy for classification


#score_interval: Specify the shortest time interval (in seconds) to wait between model scoring. This option 
#defaults to 5.

#score_training_samples: Specify the number of training set samples for scoring. The value must be >= 0. To use 
#all training samples, enter 0. This option defaults to 10000.

#regression_stop: (Regression models only) Specify the stopping criterion for regression error (MSE) on the 
#training data. When the error is at or below this threshold, training stops. To disable this option, enter -1.
#This option defaults to 1e-06.

#stopping_rounds: Stops training when the option selected for stopping_metric doesn't improve for the specified
#number of training rounds, based on a simple moving average. To disable this feature, specify 0. The metric is
#computed on the validation data (if provided); otherwise, training data is used. This option defaults to 5.

#stopping_metric: Specify the metric to use for early stopping. The available options are:
#  AUTO: This defaults to logloss for classification, deviance for regression, and anomaly_score for Isolation 
#Forest. Note that custom and custom_increasing can only be used in GBM and DRF with the Python client. Must be 
#one of: AUTO, anomaly_score. Defaults to AUTO.

#stopping_tolerance: Specify the relative tolerance for the metric-based stopping to stop training if the 
#improvement is less than this value. This option defaults to 0.

#max_runtime_secs: Maximum allowed runtime in seconds for model training. Use 0 (default) to disable.

#diagnostics: Specify whether to compute the variable importances for input features (using the Gedeon method). 
#For large networks, enabling this option can reduce speed. This option is defaults to true (enabled).

#variable_importances: Specify whether to compute variable importance. This option is defaults to true.

#autoencoder: Specify whether to enable the Deep Learning autoencoder. This option is defaults to false 
#(not enabled).

#sparse: Specify whether to enable sparse data handling, which is more efficient for data with many zero values.
#This option is defaults to false (not enabled).

#export_checkpoints_dir: Specify a directory to which generated models will automatically be exported.

#Time difference of 1.184674 days