load("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2023 01 13 KERAS auto2/.RData")
setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2023 01 13 KERAS auto2")

#LIBRARY

# Disable GPU                                                                   
Sys.setenv("CUDA_VISIBLE_DEVICES" = -1)   
   
# autoencoder in keras
suppressPackageStartupMessages(library(keras))

############DATA#########
train_data_num2<-train_data_num[,-1]
test_data_num2<-test_data_num[,-1]



x_train <- as.matrix(train_data_num2)
x_test<-as.matrix(test_data_num2)


######################################MODELIAI######################################
model <- keras_model_sequential()
model %>%
  layer_dense(units = 64, activation = "relu", input_shape = ncol(x_train)) %>%
  layer_dense(units = 16, activation = "relu", name = "bottleneck") %>%
  layer_dense(units = 64, activation = "relu") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model)

# compile model
model %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

model %>% save_model_hdf5("model_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model, x_train, x_train)
mse.ae2

##############################################################################

model2 <- keras_model_sequential()
model2 %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 16, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 64, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model2)

# compile model
model2 %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model2 %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

model2 %>% save_model_hdf5("model_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model2, x_train, x_train)
mse.ae2

##############################################################################

start.time<-Sys.time()
set.seed(321)
# fit model
model2 %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

# evaluate the performance of the model
mse.ae2 <- evaluate(model2, x_train, x_train)
mse.ae2

##############################################################################best

start.time<-Sys.time()
set.seed(5005)
# fit model
model2 %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken
model2 %>% save_model_hdf5("model2_best_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model2, x_train, x_train)
mse.ae2

##############################################################################
model2 %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.0001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(5005)
# fit model
model2 %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

# evaluate the performance of the model
mse.ae2 <- evaluate(model2, x_train, x_train)
mse.ae2


##############################################################################
model2 %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.01)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(5005)
# fit model
model2 %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

# evaluate the performance of the model
mse.ae2 <- evaluate(model2, x_train, x_train)
mse.ae2

################################################################################
#OTHER STRUCTURE
################################################################################
model_II <- keras_model_sequential()
model_II %>%
  layer_dense(units = 64, activation = "relu", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 32, activation = "relu") %>%
  layer_dense(units = 16, activation = "relu", name = "bottleneck") %>%
  layer_dense(units = 32, activation = "relu") %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 64, activation = "relu") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model)

# compile model
model_II %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_II %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

#model_II %>% save_model_hdf5("model_II_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_II, x_train, x_train)
mse.ae2

################################################################################
model_II <- keras_model_sequential()
model_II %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 32, activation = "tanh") %>%
  layer_dense(units = 16, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 32, activation = "tanh") %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 64, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model)

# compile model
model_II %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_II %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

#model_II %>% save_model_hdf5("model_II_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_II, x_train, x_train)
mse.ae2

################################################################################
model_II <- keras_model_sequential()
model_II %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  #layer_dropout(rate = 0.4)%>%
  layer_dense(units = 32, activation = "tanh") %>%
  layer_dense(units = 16, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 32, activation = "tanh") %>%
  #layer_dropout(rate = 0.4)%>%
  layer_dense(units = 64, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model)

# compile model
model_II %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_II %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

#model_II %>% save_model_hdf5("model_II_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_II, x_train, x_train)
mse.ae2

################################################################################
model_II <- keras_model_sequential()
model_II %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 32, activation = "tanh") %>%
  layer_dense(units = 16, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 32, activation = "tanh") %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 64, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model)

# compile model
model_II %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(5005)
# fit model
model_II %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

#model_II %>% save_model_hdf5("model_II_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_II, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_II, x_test, x_test)
mse.ae3


################################################################################best
model_II <- keras_model_sequential()
model_II %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  #layer_dropout(rate = 0.4)%>%
  layer_dense(units = 32, activation = "tanh") %>%
  layer_dense(units = 16, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 32, activation = "tanh") %>%
  #layer_dropout(rate = 0.4)%>%
  layer_dense(units = 64, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model)

# compile model
model_II %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_II %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

model_II %>% save_model_hdf5("model_II_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_II, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_II, x_test, x_test)
mse.ae3

################################################################################
#OTHER STRUCTURE _2
################################################################################
model_III <- keras_model_sequential()
model_III %>%
  layer_dense(units = 256, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 128, activation = "tanh") %>%
  layer_dense(units = 64, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 128, activation = "tanh") %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 256, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_III)

# compile model
model_III %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_III %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

#model_III %>% save_model_hdf5("model_III_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_III, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_III, x_test, x_test)
mse.ae3

################################################################################
#OTHER STRUCTURE _2
################################################################################
model_III <- keras_model_sequential()
model_III %>%
  layer_dense(units = 128, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 64, activation = "tanh") %>%
  layer_dense(units = 32, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 64, activation = "tanh") %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 128, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_III)

# compile model
model_III %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_III %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

#model_III %>% save_model_hdf5("model_III_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_III, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_III, x_test, x_test)
mse.ae3

################################################################################
#OTHER STRUCTURE _2
################################################################################
model_III <- keras_model_sequential()
model_III %>%
  layer_dense(units = 32, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 16, activation = "tanh") %>%
  layer_dense(units = 8, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 16, activation = "tanh") %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 32, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_III)

# compile model
model_III %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_III %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

#model_III %>% save_model_hdf5("model_III_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_III, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_III, x_test, x_test)
mse.ae3


################################################################################
#OTHER STRUCTURE _2
################################################################################
model_III <- keras_model_sequential()
model_III %>%
  layer_dense(units = 16, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 8, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 16, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_III)

# compile model
model_III %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_III %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

#model_III %>% save_model_hdf5("model_III_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_III, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_III, x_test, x_test)
mse.ae3

################################################################################
#OTHER STRUCTURE _2
################################################################################
model_III <- keras_model_sequential()
model_III %>%
  layer_dense(units = 8, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 4, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 8, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_III)

# compile model
model_III %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_III %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

#model_III %>% save_model_hdf5("model_III_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_III, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_III, x_test, x_test)
mse.ae3

################################################################################
#OTHER STRUCTURE _2
################################################################################
model_III <- keras_model_sequential()
model_III %>%
  layer_dense(units = 32, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 16, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 32, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_III)

# compile model
model_III %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_III %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

#model_III %>% save_model_hdf5("model_III_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_III, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_III, x_test, x_test)
mse.ae3

################################################################################
#OTHER STRUCTURE _2
################################################################################
model_III <- keras_model_sequential()
model_III %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 32, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 64, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_III)

# compile model
model_III %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_III %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

#model_III %>% save_model_hdf5("model_III_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_III, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_III, x_test, x_test)
mse.ae3

################################################################################
#OTHER STRUCTURE _2
################################################################################
model_III <- keras_model_sequential()
model_III %>%
  layer_dense(units = 128, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 64, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 128, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_III)

# compile model
model_III %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_III %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

#model_III %>% save_model_hdf5("model_III_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_III, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_III, x_test, x_test)
mse.ae3

################################################################################
#OTHER STRUCTURE _2
################################################################################
model_III <- keras_model_sequential()
model_III %>%
  layer_dense(units = 256, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 128, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 256, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_III)

# compile model
model_III %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_III %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

model_III %>% save_model_hdf5("model_III_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_III, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_III, x_test, x_test)
mse.ae3

################################################################################
#OTHER STRUCTURE _2
################################################################################
model_IV <- keras_model_sequential()
model_IV %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train), name = "bottleneck") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_IV)

# compile model
model_IV %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_IV %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

#model_III %>% save_model_hdf5("model_IV_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_IV, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_IV, x_test, x_test)
mse.ae3

################################################################################
#OTHER STRUCTURE _2
################################################################################
model_IV <- keras_model_sequential()
model_IV %>%
  layer_dense(units = 32, activation = "tanh", input_shape = ncol(x_train), name = "bottleneck") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_IV)

# compile model
model_IV %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_IV %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

#model_III %>% save_model_hdf5("model_IV_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_IV, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_IV, x_test, x_test)
mse.ae3



########################################################################################
#SELECTED
#####################################################################################
model_III <- keras_model_sequential()
model_III %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 32, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 64, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_III)

# compile model
model_III %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_III %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

model_III %>% save_model_hdf5("model_III_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_III, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_III, x_test, x_test)
mse.ae3

intermediate_layer_model <- keras_model(inputs = model_III$input, outputs = get_layer(model_III, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
train3<-as.data.frame(intermediate_output)
Test_intermediate_output <- predict(intermediate_layer_model, x_test)
test3<-as.data.frame(Test_intermediate_output)

plot(train3$V1, train3$V2, pch=18, xlab='1 bottleneck', col=train_data_num$TARGET, ylab='2 bottleneck', main = 'TRAIN')
plot(test3$V1, test3$V2, pch=18, xlab='1 bottleneck', col=test_data_num$TARGET, ylab='2 bottleneck', main = 'Test')


train3<-cbind(train_data_num[,1], train3)
test3<-cbind(test_data_num[,1], test3)


########################################################################################
#SELECTED2
#####################################################################################
model_IV <- keras_model_sequential()
model_IV %>%
  layer_dense(units = 128, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 64, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 128, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_IV)

# compile model
model_IV %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_IV %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

model_IV %>% save_model_hdf5("model_III_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_IV, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_IV, x_test, x_test)
mse.ae3

intermediate_layer_model <- keras_model(inputs = model_IV$input, outputs = get_layer(model_IV, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
train4<-as.data.frame(intermediate_output)
Test_intermediate_output <- predict(intermediate_layer_model, x_test)
test4<-as.data.frame(Test_intermediate_output)

plot(train4$V1, train4$V2, pch=18, xlab='1 bottleneck', col=train_data_num$TARGET, ylab='2 bottleneck', main = 'TRAIN')
plot(test4$V1, test4$V2, pch=18, xlab='1 bottleneck', col=test_data_num$TARGET, ylab='2 bottleneck', main = 'Test')


train4<-cbind(train_data_num[,1], train4)
test4<-cbind(test_data_num[,1], test4)

########################################################################################
#SELECTED3
#####################################################################################
model_V <- keras_model_sequential()
model_V %>%
  layer_dense(units = 256, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 100, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 256, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_V)

# compile model
model_V %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_V %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

model_V %>% save_model_hdf5("model_V_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_V, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_V, x_test, x_test)
mse.ae3

intermediate_layer_model <- keras_model(inputs = model_V$input, outputs = get_layer(model_V, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
train5<-as.data.frame(intermediate_output)
Test_intermediate_output <- predict(intermediate_layer_model, x_test)
test5<-as.data.frame(Test_intermediate_output)

plot(train5$V1, train4$V2, pch=18, xlab='1 bottleneck', col=train_data_num$TARGET, ylab='2 bottleneck', main = 'TRAIN')
plot(test5$V1, test4$V2, pch=18, xlab='1 bottleneck', col=test_data_num$TARGET, ylab='2 bottleneck', main = 'Test')


train5<-cbind(train_data_num[,1], train5)
test5<-cbind(test_data_num[,1], test5)

################################################################################
#OTHER STRUCTURE
################################################################################
model_VI <- keras_model_sequential()
model_VI %>%
  layer_dense(units = 512, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 128, activation = "tanh") %>%
  layer_dense(units = 64, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 128, activation = "tanh") %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 512, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_VI)

# compile model
model_VI %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_VI %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

model_VI %>% save_model_hdf5("model_VI_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_VI, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_VI, x_test, x_test)
mse.ae3


intermediate_layer_model <- keras_model(inputs = model_VI$input, outputs = get_layer(model_VI, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
train6<-as.data.frame(intermediate_output)
Test_intermediate_output <- predict(intermediate_layer_model, x_test)
test6<-as.data.frame(Test_intermediate_output)

plot(train6$V1, train6$V2, pch=18, xlab='1 bottleneck', col=train_data_num$TARGET, ylab='2 bottleneck', main = 'TRAIN')
plot(test6$V1, test6$V2, pch=18, xlab='1 bottleneck', col=test_data_num$TARGET, ylab='2 bottleneck', main = 'Test')


train6<-cbind(train_data_num[,1], train6)
test6<-cbind(test_data_num[,1], test6)

################################################################################
#OTHER STRUCTURE
################################################################################
model_VII <- keras_model_sequential()
model_VII %>%
  layer_dense(units = 700, activation = "relu", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 300, activation = "relu") %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 100, activation = "relu") %>%
  layer_dense(units = 50, activation = "relu", name = "bottleneck") %>%
  layer_dense(units = 100, activation = "relu") %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 300, activation = "relu") %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 700, activation = "relu") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_VII)

# compile model
model_VII %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_VII %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

model_VII %>% save_model_hdf5("model_VI_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_VII, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_VII, x_test, x_test)
mse.ae3

################################################################################
#OTHER STRUCTURE
################################################################################
model_VII <- keras_model_sequential()
model_VII %>%
  layer_dense(units = 1024, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 512, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 128, activation = "tanh") %>%
  layer_dense(units = 64, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 128, activation = "tanh") %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 512, activation = "tanh") %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 1024, activation = "tanh") %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_VII)

# compile model
model_VII %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_VII %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 30,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

model_VII %>% save_model_hdf5("model_VII_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_VII, x_train, x_train)
mse.ae2

mse.ae3 <- evaluate(model_VII, x_test, x_test)
mse.ae3

intermediate_layer_model <- keras_model(inputs = model_VII$input, outputs = get_layer(model_VII, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
train7<-as.data.frame(intermediate_output)
Test_intermediate_output <- predict(intermediate_layer_model, x_test)
test7<-as.data.frame(Test_intermediate_output)

plot(train7$V1, train7$V2, pch=18, xlab='1 bottleneck', col=train_data_num$TARGET, ylab='2 bottleneck', main = 'TRAIN')
plot(test7$V1, test7$V2, pch=18, xlab='1 bottleneck', col=test_data_num$TARGET, ylab='2 bottleneck', main = 'Test')

train7<-cbind(train_data_num[,1], train7)
test7<-cbind(test_data_num[,1], test7)

