setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG")
#pastobos, smote prikuria nauju reiksmiu pabaigoje, todel rows identifikacija 
#leidzia su train set tikrasiais reiksmes su pirminemis reiksmemis duomenu eiluteje

TRAIN_ALL_atr<-subset(Koreliacija_data_order, STATUS_YEAR_GROUP !=2022)
TEST_ALL_atr<-subset(Koreliacija_data_order, STATUS_YEAR_GROUP ==2022)

TRAIN_ALL_atr<-TRAIN_ALL_atr[,-c(1,3:5)]
TEST_ALL_atr<-TEST_ALL_atr[,-c(1,3:5)]
df<-TRAIN_ALL_atr
library(caret)
df<-preProcess(df, method=c("range"))
train_data<-predict(df, TRAIN_ALL_atr)
test_data<-predict(df, TEST_ALL_atr)
train_data[is.na(train_data)] = 0
test_data[is.na(test_data)] = 0

names(train_data)[1]<-'TARGET'
names(test_data)[1]<-'TARGET'
train_data$TARGET<-as.factor(train_data$TARGET)
test_data$TARGET<-as.factor(test_data$TARGET)

#Variation check
table(train_data$T_1_Long_yield_MAX, useNA = 'always')
table(train_data$T_2_Long_yield_MIN, useNA = 'always')
table(train_data$T_2_Long_yield_LAST_VALUE, useNA = 'always')
table(train_data$Active_owner_at_the_same_time, useNA = 'always')
#trys atmetami
a_names<-c('T_1_Long_yield_MAX','T_2_Long_yield_MIN', 'T_2_Long_yield_LAST_VALUE')
b_values<-which(names(train_data) %in% a_names)
train_data<-train_data[,-c(b_values)]
test_data<-test_data[,-c(b_values)]

a_names<-NA
for (i in 2:dim(train_data)[2]){
  print(names(train_data)[i])
  if(length(which(!(names(table(train_data[,i])) %in% c(0,1)))) == 0)
  {a_names<-append(a_names, names(train_data)[i])}}

a_names<-a_names[-1]
a_names

a_names<-a_names[-c(11,14,15,22)]

b_values<-which(names(train_data) %in% a_names)
a_names
for (i in b_values){
  print(i)
  train_data[,i]<-as.factor(train_data[,i])
  test_data[,i]<-as.factor(test_data[,i])
}

library(themis)
smotenc_data<-smotenc(train_data, var = 'TARGET', k = 5, over_ratio = 1)
table(smotenc_data$TARGET)

smotenc_data$the_same<-Reduce(`&`, Map(`==`, train_data, smotenc_data))
smotenc_data$row_number<-row.names(smotenc_data)

train_data<-smotenc_data[,]

set.seed(7)
rows <- sample(nrow(train_data))
train_data<-train_data[rows,]

last_columns<-length(train_data)
last_columns<-as.numeric(last_columns)
last_columns<-append(last_columns,last_columns-1)

Train_data_rows_identification<-train_data[,last_columns]

train_data<-train_data[,-c(last_columns)]
#########################################################################################
#                           MODELIAI
########################################################################################
expected_value <- factor(c(test_data[,(1)]))
Predicted_values<-as.data.frame(test_data$TARGET)
names(Predicted_values)[1]<-'Real_target'
########################################################################################

reg_model<-glm(TARGET~.,  data=train_data[,1:2], family = binomial(link = 'logit'))
reg_model
summary(reg_model)


a_names<-"none"
a_names<-a_names[-1]
train_used<-train_data[,c(1:2)]

for (i in (1:dim(train_used)[2])){
  print(paste('v',i, sep='_'))
  a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
  a_value<-as.numeric(a_order[1])
  if (a_value==1){
    a_value<-as.numeric(a_order[2])
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_used) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))
    }}
  else{
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_used) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))}
  }
}

summary(reg_model)

#PREDICT
pred<-predict(reg_model,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$LG_Corr_1<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

Palyginimo<-as.data.frame(bin_cm$record_level_cm)
a<-names(Palyginimo)
a<-a[c(1:6,12,13,16,17,18,22)]
Palyginimo<-Palyginimo[,which(names(Palyginimo) %in% a)]
library(MLmetrics)
Palyginimo$AUC<-AUC(predicted_value, expected_value)
library(dgof)
Palyginimo$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
Palyginimo$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
Palyginimo$Error_rate<-1-Palyginimo$Accuracy
Palyginimo$Type_I_err<-Palyginimo$Pred_0_Ref_1/(Palyginimo$Pred_0_Ref_1+Palyginimo$Pred_1_Ref_1)
Palyginimo$Type_II_err<-Palyginimo$Pred_1_Ref_0/(Palyginimo$Pred_1_Ref_0+Palyginimo$Pred_0_Ref_0)
Palyginimo$MCC<-((Palyginimo$Pred_0_Ref_0*Palyginimo$Pred_1_Ref_1)-(Palyginimo$Pred_1_Ref_0*Palyginimo$Pred_0_Ref_1))/
  sqrt(as.numeric(Palyginimo$Pred_0_Ref_0+Palyginimo$Pred_1_Ref_0)*as.numeric(Palyginimo$Pred_0_Ref_0+Palyginimo$Pred_0_Ref_1)*as.numeric(Palyginimo$Pred_1_Ref_1+Palyginimo$Pred_1_Ref_0)*as.numeric((Palyginimo$Pred_1_Ref_1+Palyginimo$Pred_0_Ref_1)))
Palyginimo$G_mean<-sqrt(as.numeric(Palyginimo$Recall)*as.numeric(Palyginimo$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-peCorrormance-of-credit-score-models-59fe13ef420
Palyginimo$Gini<-2*Palyginimo$AUC-1
Palyginimo$Modelis<-"LG_Corr_1"

saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/", "LG_Corr_", 1, ".rda"))

#LG_1 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/LG_Corr_1.rda")
#summary(LG_1)

######################2#################

reg_model<-glm(TARGET~.,  data=train_data[,c(1:3)], family = binomial(link = 'logit'))
reg_model
summary(reg_model)


a_names<-"none"
a_names<-a_names[-1]
train_used<-train_data[,c(1:3)]

for (i in (1:dim(train_used)[2])){
  print(paste('v',i, sep='_'))
  a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
  a_value<-as.numeric(a_order[1])
  if (a_value==1){
    a_value<-as.numeric(a_order[2])
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_used) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))
    }}
  else{
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(train_used) %in% a_names))
      reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))}
  }
}

summary(reg_model)

#PREDICT
pred<-predict(reg_model,test_data[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))
Predicted_values$aa<-predicted_value
col_name <- paste0("LG_Corr_", 2)
colnames(Predicted_values)[3] <- col_name

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
library(MLmetrics)
New_row_pal$AUC<-AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-peCorrormance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-paste('LG_Corr_',2)
Palyginimo<-rbind(Palyginimo, New_row_pal)
saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/", "LG_Corr_", 2, ".rda"))

###############################################################
#                        3-15 cikliukas
################################################
Palyginimo<-read.csv("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/Corr_LG_pal.csv")
Predicted_values<- read.csv("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/Corr_LG_values.csv")
Palyginimo<-Palyginimo[,-c(1)]
Predicted_values<-Predicted_values[,-c(1)]
setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG")
library(dgof)
library(MLmetrics)
library('ConfusionTableR')

train_used<-train_data[,]

for (j in (3:15)){
  print(j)
  n<-j+1
  train_used<-train_data[,c(1:n)]
  reg_model<-glm(TARGET~.,  data=train_used[,c(1:n)], family = binomial(link = 'logit'))
  a_names<-"none"
  a_names<-a_names[-1]
  for (i in (1:n)){
    print(paste('v',j,i, sep='_'))
    a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
    a_value<-as.numeric(a_order[1])
    if (a_value==1){
      a_value<-as.numeric(a_order[2])
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))
      }}
    else{
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))}
    }
  }
  pred<-predict(reg_model,test_data[,-c(1)])
  pred2<-ifelse(pred >= 0.5, 1, 0)
  predicted_value <- factor(c(pred2))
  Predicted_values$aa<-predicted_value
  col_name <- paste0("LG_Corr_", j)
  colnames(Predicted_values)[n] <- col_name
  
  bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
  New_row_pal<-as.data.frame(bin_cm$record_level_cm)
  New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
  New_row_pal$AUC<-AUC(predicted_value, expected_value)
  New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
  New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
  New_row_pal$Error_rate<-1-New_row_pal$Accuracy
  New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
  New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
  New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
    sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
  New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
  New_row_pal$Gini<-2*New_row_pal$AUC-1
  New_row_pal$Modelis<-paste('LG_Corr_',j)
  Palyginimo<-rbind(Palyginimo, New_row_pal)
  
  saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/", "LG_Corr_", j, ".rda"))
  write.csv(Palyginimo, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/Corr_LG_pal.csv")
  write.csv(Predicted_values, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/Corr_LG_values.csv")
}

#LG_1 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/LG_Corr_15.rda")
#summary(LG_1)

###############################################################
#                        16:50 cikliukas
#51-100
################################################

setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG")
library(dgof)
library(MLmetrics)
library('ConfusionTableR')

train_used<-train_data[,]

for (j in (112:150)){
  print(j)
  n<-j+1
  train_used<-train_data[,c(1:n)]
  reg_model<-glm(TARGET~.,  data=train_used[,c(1:n)], family = binomial(link = 'logit'))
  a_names<-"none"
  a_names<-a_names[-1]
  for (i in (1:n)){
    print(paste('v',j,i, sep='_'))
    a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
    a_value<-as.numeric(a_order[1])
    if (a_value==1){
      a_value<-as.numeric(a_order[2])
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))
      }}
    else{
      bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
      if (bigger==TRUE) {
        a_names<-append(a_names, names(reg_model$coefficients[a_value]))
        b_names<-as.numeric(which(names(train_used) %in% a_names))
        reg_model<-glm(TARGET~.,  data=train_used[,-c(b_names)], family = binomial(link = 'logit'))}
    }
  }
  pred<-predict(reg_model,test_data[,-c(1)])
  pred2<-ifelse(pred >= 0.5, 1, 0)
  predicted_value <- factor(c(pred2))
  Predicted_values$aa<-predicted_value
  col_name <- paste0("LG_Corr_", j)
  colnames(Predicted_values)[n] <- col_name
  
  bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
  New_row_pal<-as.data.frame(bin_cm$record_level_cm)
  New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
  New_row_pal$AUC<-AUC(predicted_value, expected_value)
  New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
  New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
  New_row_pal$Error_rate<-1-New_row_pal$Accuracy
  New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
  New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
  New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
    sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
  New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
  New_row_pal$Gini<-2*New_row_pal$AUC-1
  New_row_pal$Modelis<-paste('LG_Corr_',j)
  Palyginimo<-rbind(Palyginimo, New_row_pal)
  
  saveRDS(reg_model, file = paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/", "LG_Corr_", j, ".rda"))
  write.csv(Palyginimo, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/Corr_LG_pal.csv")
  write.csv(Predicted_values, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/Corr_LG_values.csv")
}



#########################################################################################

LG_1 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/LG_Corr_1.rda")
summary(LG_1)

Skaicius<-as.data.frame(LG_1$coefficients)
Skaicius$Feature<-row.names(Skaicius)
Skaicius<-Skaicius[,c(2,1)]
names(Skaicius)[2]<-'LG_RF_1'

LG_2 = readRDS("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/LG_Corr_2.rda")

df<-as.data.frame(LG_2$coefficients)
df$Feature<-row.names(df)
df<-df[,c(2,1)]
names(df)[2]<-'LG_RF_2'

library(dplyr)
Skaicius<-full_join(Skaicius, df, by = "Feature")


Reiksmingumas<-data.frame('LG_RF_1', with(summary(LG_1), 1 - deviance/null.deviance))
names(Reiksmingumas)[1]<-'Modelis'
names(Reiksmingumas)[2]<-'R2'

df2<-data.frame('LG_RF_2', with(summary(LG_2), 1 - deviance/null.deviance))
names(df2)[1]<-'Modelis'
names(df2)[2]<-'R2'

Reiksmingumas<-rbind(Reiksmingumas,df2)


for (j in (3:10)){
  print(j)
  LG_2 = readRDS(paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/", "LG_Corr_", j, ".rda"))
  df<-as.data.frame(LG_2$coefficients)
  df$Feature<-row.names(df)
  names(df)[1]<-paste0("LG_RF_", j)
  Skaicius<-full_join(Skaicius, df, by = "Feature")
  df2<-data.frame(paste0('LG_RF_', j), with(summary(LG_2), 1 - deviance/null.deviance))
  names(df2)<-c('Modelis', 'R2')
  Reiksmingumas<-rbind(Reiksmingumas,df2)}



for (j in (11:100)){
  print(j)
  LG_2 = readRDS(paste0("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/", "LG_Corr_", j, ".rda"))
  df<-as.data.frame(LG_2$coefficients)
  df$Feature<-row.names(df)
  names(df)[1]<-paste0("LG_RF_", j)
  Skaicius<-full_join(Skaicius, df, by = "Feature")
  df2<-data.frame(paste0('LG_RF_', j), with(summary(LG_2), 1 - deviance/null.deviance))
  names(df2)<-c('Modelis', 'R2')
  Reiksmingumas<-rbind(Reiksmingumas,df2)}

write.csv(Reiksmingumas, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/Corr_reiksmingumas.csv")
write.csv(Skaicius, "C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/MODELIAI/2023 01 20 Corr LG/Corr_skaicius.csv")
