setwd("C:/Users/Dovile/Desktop/Disertacija/DATA 22_08/AAA_R_DATA/2023 01 28 AUTO dalimisII")

#################################################################################
##AUTOENCODER
# Disable GPU                                                                   
Sys.setenv("CUDA_VISIBLE_DEVICES" = -1)   
# autoencoder in keras
suppressPackageStartupMessages(library(keras))
################################################################################

################################################################################
#TYPE
################################################################################

x_train <- as.matrix(train_type)
x_test<-as.matrix(test_type)

set.seed(123)
model_type <- keras_model_sequential()
model_type %>%
  layer_dense(units = 2, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 1, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 2, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_type)

# compile model
model_type %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_type %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

model_type %>% save_model_hdf5("model_type_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_type, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_type, x_test, x_test)
mse.ae2

intermediate_layer_model <- keras_model(inputs = model_type$input, outputs = get_layer(model_type, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)

names(df_train)<-paste0('Type_', names(df_train))
names(df_test)<-paste0('Type_', names(df_test))

TRAIN_full<-cbind(train_data_num[,1], df_train)
TEST_full<-cbind(test_data_num[,1], df_test)
names(TRAIN_full)[1]<-'TARGET'
names(TEST_full)[1]<-'TARGET'

################################################################################
#VMI
################################################################################

x_train <- as.matrix(train_VMI)
x_test<-as.matrix(test_VMI)

set.seed(123)
model_VMI <- keras_model_sequential()
model_VMI %>%
  layer_dense(units = 2, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 1, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 2, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_VMI)

# compile model
model_VMI %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_VMI %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

model_VMI %>% save_model_hdf5("model_VMI_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_VMI, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_VMI, x_test, x_test)
mse.ae2

intermediate_layer_model <- keras_model(inputs = model_VMI$input, outputs = get_layer(model_VMI, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)

names(df_train)<-paste0('VMI_', names(df_train))
names(df_test)<-paste0('VMI_', names(df_test))

TRAIN_full<-cbind(TRAIN_full, df_train)
TEST_full<-cbind(TEST_full, df_test)


################################################################################
#OTHER
################################################################################

x_train <- as.matrix(train_other)
x_test<-as.matrix(test_other)

set.seed(123)
model_other <- keras_model_sequential()
model_other %>%
  layer_dense(units = 4, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 2, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 4, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_other)

# compile model
model_other %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_other %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

model_other %>% save_model_hdf5("model_other_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_other, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_other, x_test, x_test)
mse.ae2

intermediate_layer_model <- keras_model(inputs = model_other$input, outputs = get_layer(model_other, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)

names(df_train)<-paste0('other_', names(df_train))
names(df_test)<-paste0('other_', names(df_test))

TRAIN_full<-cbind(TRAIN_full, df_train)
TEST_full<-cbind(TEST_full, df_test)


################################################################################
#coart
################################################################################

x_train <- as.matrix(train_cort)
x_test<-as.matrix(test_cort)

set.seed(123)
model_cort <- keras_model_sequential()
model_cort %>%
  layer_dense(units = 4, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 2, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 4, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_cort)

# compile model
model_cort %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_cort %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

model_cort %>% save_model_hdf5("model_cort_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_cort, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_cort, x_test, x_test)
mse.ae2

intermediate_layer_model <- keras_model(inputs = model_cort$input, outputs = get_layer(model_cort, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)

names(df_train)<-paste0('cort_', names(df_train))
names(df_test)<-paste0('cort_', names(df_test))

TRAIN_full<-cbind(TRAIN_full, df_train)
TEST_full<-cbind(TEST_full, df_test)

################################################################################
#board
################################################################################

x_train <- as.matrix(train_Board)
x_test<-as.matrix(test_Board)

set.seed(123)
model_Board <- keras_model_sequential()
model_Board %>%
  layer_dense(units = 8, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 2, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 8, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_Board)

# compile model
model_Board %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_Board %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

model_Board %>% save_model_hdf5("model_Board_autocoder.h5")

# evaluate the performance of the model
mse.ae2 <- evaluate(model_Board, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_Board, x_test, x_test)
mse.ae2

intermediate_layer_model <- keras_model(inputs = model_Board$input, outputs = get_layer(model_Board, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)

names(df_train)<-paste0('Board_', names(df_train))
names(df_test)<-paste0('Board_', names(df_test))

TRAIN_full<-cbind(TRAIN_full, df_train)
TEST_full<-cbind(TEST_full, df_test)


################################################################################
#sector_class
################################################################################

x_train <- as.matrix(train_sector_class)
x_test<-as.matrix(test_sector_class)

set.seed(123)
model_sector_class <- keras_model_sequential()
model_sector_class %>%
  layer_dense(units = 8, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 2, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 8, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_sector_class)

# compile model
model_sector_class %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_sector_class %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

# evaluate the performance of the model
mse.ae2 <- evaluate(model_sector_class, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_sector_class, x_test, x_test)
mse.ae2

model_sector_class %>% save_model_hdf5("model_sector_class_autocoder.h5")

intermediate_layer_model <- keras_model(inputs = model_sector_class$input, outputs = get_layer(model_sector_class, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)

names(df_train)<-paste0('sector_class_', names(df_train))
names(df_test)<-paste0('sector_class_', names(df_test))

TRAIN_full<-cbind(TRAIN_full, df_train)
TEST_full<-cbind(TEST_full, df_test)

################################################################################
#balance
################################################################################

x_train <- as.matrix(train_balance)
x_test<-as.matrix(test_balance)

set.seed(123)
model_balance <- keras_model_sequential()
model_balance %>%
  layer_dense(units = 32, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 8, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 32, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_balance)

# compile model
model_balance %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_balance %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

# evaluate the performance of the model
mse.ae2 <- evaluate(model_balance, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_balance, x_test, x_test)
mse.ae2

model_balance %>% save_model_hdf5("model_balance_autocoder.h5")

intermediate_layer_model <- keras_model(inputs = model_balance$input, outputs = get_layer(model_balance, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)

names(df_train)<-paste0('balance_', names(df_train))
names(df_test)<-paste0('balance_', names(df_test))

TRAIN_full<-cbind(TRAIN_full, df_train)
TEST_full<-cbind(TEST_full, df_test)


################################################################################
#ratio
################################################################################

x_train <- as.matrix(train_ratio)
x_test<-as.matrix(test_ratio)
set.seed(123)
model_ratio <- keras_model_sequential()
model_ratio %>%
  layer_dense(units = 32, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 8, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 32, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_ratio)

# compile model
model_ratio %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_ratio %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

# evaluate the performance of the model
mse.ae2 <- evaluate(model_ratio, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_ratio, x_test, x_test)
mse.ae2

model_ratio %>% save_model_hdf5("model_ratio_autocoder.h5")

intermediate_layer_model <- keras_model(inputs = model_ratio$input, outputs = get_layer(model_ratio, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)

names(df_train)<-paste0('ratio_', names(df_train))
names(df_test)<-paste0('ratio_', names(df_test))

TRAIN_full<-cbind(TRAIN_full, df_train)
TEST_full<-cbind(TEST_full, df_test)

################################################################################
#sector_ratio
################################################################################

x_train <- as.matrix(train_sector_ratio)
x_test<-as.matrix(test_sector_ratio)
set.seed(123)
model_sector_ratio <- keras_model_sequential()
model_sector_ratio %>%
  layer_dense(units = 32, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 8, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 32, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_sector_ratio)

# compile model
model_sector_ratio %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_sector_ratio %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

# evaluate the performance of the model
mse.ae2 <- evaluate(model_sector_ratio, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_sector_ratio, x_test, x_test)
mse.ae2

model_sector_ratio %>% save_model_hdf5("model_sector_ratio_autocoder.h5")

intermediate_layer_model <- keras_model(inputs = model_sector_ratio$input, outputs = get_layer(model_sector_ratio, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)

names(df_train)<-paste0('sector_ratio_', names(df_train))
names(df_test)<-paste0('sector_ratio_', names(df_test))

TRAIN_full<-cbind(TRAIN_full, df_train)
TEST_full<-cbind(TEST_full, df_test)

#Sodra_emp
################################################################################

x_train <- as.matrix(train_Sodra_emp)
x_test<-as.matrix(test_Sodra_emp)
set.seed(123)
model_Sodra_emp <- keras_model_sequential()
model_Sodra_emp %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 8, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_Sodra_emp)

# compile model
model_Sodra_emp %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_Sodra_emp %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

# evaluate the performance of the model
mse.ae2 <- evaluate(model_Sodra_emp, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_Sodra_emp, x_test, x_test)
mse.ae2

model_Sodra_emp %>% save_model_hdf5("model_Sodra_emp_autocoder.h5")

intermediate_layer_model <- keras_model(inputs = model_Sodra_emp$input, outputs = get_layer(model_Sodra_emp, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)

names(df_train)<-paste0('Sodra_emp_', names(df_train))
names(df_test)<-paste0('Sodra_emp_', names(df_test))

TRAIN_full<-cbind(TRAIN_full, df_train)
TEST_full<-cbind(TEST_full, df_test)

#Sodra_Delay
################################################################################

x_train <- as.matrix(train_Sodra_Delay)
x_test<-as.matrix(test_Sodra_Delay)
set.seed(123)
model_Sodra_Delay <- keras_model_sequential()
model_Sodra_Delay %>%
  layer_dense(units = 128, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 16, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 128, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_Sodra_Delay)

# compile model
model_Sodra_Delay %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_Sodra_Delay %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

# evaluate the performance of the model
mse.ae2 <- evaluate(model_Sodra_Delay, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_Sodra_Delay, x_test, x_test)
mse.ae2

model_Sodra_Delay %>% save_model_hdf5("model_Sodra_Delay_autocoder.h5")

intermediate_layer_model <- keras_model(inputs = model_Sodra_Delay$input, outputs = get_layer(model_Sodra_Delay, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)

names(df_train)<-paste0('Sodra_Delay_', names(df_train))
names(df_test)<-paste0('Sodra_Delay_', names(df_test))

TRAIN_full<-cbind(TRAIN_full, df_train)
TEST_full<-cbind(TEST_full, df_test)



################################################################################
#MAKRO
################################################################################

x_train <- as.matrix(train_makro)
x_test<-as.matrix(test_makro)

set.seed(123)
model_makro <- keras_model_sequential()
model_makro %>%
  layer_dense(units = 128, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 16, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 128, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_makro)

# compile model
model_makro %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_makro %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

# evaluate the performance of the model
mse.ae2 <- evaluate(model_makro, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_makro, x_test, x_test)
mse.ae2


model_makro %>% save_model_hdf5("model_makro_autocoder.h5")

intermediate_layer_model <- keras_model(inputs = model_makro$input, outputs = get_layer(model_makro, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)
cor(df_train)
plot(df_train)

names(df_train)<-paste0('Makro', names(df_train))
names(df_test)<-paste0('Makro', names(df_test))

TRAIN_full<-cbind(TRAIN_full, df_train)
TEST_full<-cbind(TEST_full, df_test)


################################################################################
#MAKRO 2
################################################################################

x_train <- as.matrix(train_makro)
x_test<-as.matrix(test_makro)

set.seed(123)
model_makro2 <- keras_model_sequential()
model_makro2 %>%
  layer_dense(units = 128, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 2, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 128, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_makro2)

# compile model
model_makro2 %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_makro2 %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

# evaluate the performance of the model
mse.ae2 <- evaluate(model_makro2, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_makro2, x_test, x_test)
mse.ae2


model_makro2 %>% save_model_hdf5("model_makro2_autocoder.h5")

intermediate_layer_model <- keras_model(inputs = model_makro2$input, outputs = get_layer(model_makro2, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)
cor(df_train)

plot(df_train)
names(df_train)<-paste0('Makro', names(df_train))
names(df_test)<-paste0('Makro', names(df_test))

TRAIN_full1<-TRAIN_full[,]
TEST_full1<-TEST_full[,]
TRAIN_full<-TRAIN_full[,-c(60:75)]
TEST_full<-TEST_full[,-c(60:75)]
TRAIN_full<-cbind(TRAIN_full, df_train)
TEST_full<-cbind(TEST_full, df_test)

write.csv(cor(TRAIN_full[,-c(1)]), 'C:/Users/Dovile/Desktop/kor.csv')

#############################################################################################
#Koreliuoja
###########################################################################################
names(TRAIN_full)
cor(TRAIN_full[,c(4,5)])
cor(TRAIN_full[,c(6,7)])
cor(TRAIN_full[,c(8,9)])
cor(TRAIN_full[,c(10,11)])
cor(TRAIN_full[,c(12:19)])
#plot(TRAIN_full[,c(12:19)])

################################################################################
#balance
################################################################################

x_train <- as.matrix(train_balance)
x_test<-as.matrix(test_balance)

set.seed(123)
model_balance2 <- keras_model_sequential()
model_balance2 %>%
  layer_dense(units = 32, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 4, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 32, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_balance2)

# compile model
model_balance2 %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_balance2 %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

# evaluate the performance of the model
mse.ae2 <- evaluate(model_balance2, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_balance2, x_test, x_test)
mse.ae2

model_balance2 %>% save_model_hdf5("model_balance2_autocoder.h5")

intermediate_layer_model <- keras_model(inputs = model_balance2$input, outputs = get_layer(model_balance2, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)
cor(df_train)

names(df_train)<-paste0('balance_', names(df_train))
names(df_test)<-paste0('balance_', names(df_test))

TRAIN_full<-TRAIN_full[,-c(12:19)]
TEST_full<-TEST_full[,-c(12:19)]

TRAIN_full<-cbind(TRAIN_full, df_train)
TEST_full<-cbind(TEST_full, df_test)

names(TRAIN_full)
cor(TRAIN_full[,c(12:19)])
cor(TRAIN_full[,c(20:27)])
cor(TRAIN_full[,c(28:36)])

#SODRA EMPL
x_train <- as.matrix(train_Sodra_emp)
x_test<-as.matrix(test_Sodra_emp)
set.seed(123)
model_Sodra_emp2 <- keras_model_sequential()
model_Sodra_emp2 %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 2, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_Sodra_emp2)

# compile model
model_Sodra_emp2 %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_Sodra_emp2 %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

# evaluate the performance of the model
mse.ae2 <- evaluate(model_Sodra_emp2, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_Sodra_emp2, x_test, x_test)
mse.ae2

model_Sodra_emp2 %>% save_model_hdf5("model_Sodra_emp2_autocoder.h5")

intermediate_layer_model <- keras_model(inputs = model_Sodra_emp2$input, outputs = get_layer(model_Sodra_emp2, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)
cor(df_train)

names(df_train)<-paste0('Sodra_emp_', names(df_train))
names(df_test)<-paste0('Sodra_emp_', names(df_test))

TRAIN_full<-TRAIN_full[,-c(28:36)]
TEST_full<-TEST_full[,-c(28:36)]

TRAIN_full<-cbind(TRAIN_full, df_train)
TEST_full<-cbind(TEST_full, df_test)

names(TRAIN_full1)
cor(TRAIN_full1[,c(28:42)])
TRAIN_full<-TRAIN_full[,-c(28:42)]
TEST_full<-TEST_full[,-c(28:42)]

x_train <- as.matrix(train_Sodra_Delay)
x_test<-as.matrix(test_Sodra_Delay)
set.seed(123)
model_Sodra_Delay2 <- keras_model_sequential()
model_Sodra_Delay2 %>%
  layer_dense(units = 128, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = 8, activation = "tanh", name = "bottleneck") %>%
  layer_dense(units = 64, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dropout(rate = 0.4)%>%
  layer_dense(units = 128, activation = "tanh", input_shape = ncol(x_train)) %>%
  layer_dense(units = ncol(x_train))

# view model layers
summary(model_Sodra_Delay2)

# compile model
model_Sodra_Delay2 %>% compile(
  loss = "mean_squared_error", 
  optimizer =  optimizer_adam(lr = 0.001)
) #"adam"## aksciau 0.2 greiciau judes, neprasoks lokalus minimas

start.time<-Sys.time()
set.seed(123)
# fit model
model_Sodra_Delay2 %>% fit(
  x = x_train, 
  y = x_train, 
  batch_size = 32,
  epochs = 10,
  validation_split = 0.2,
  verbose = 2 #training process showing
)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken

# evaluate the performance of the model
mse.ae2 <- evaluate(model_Sodra_Delay2, x_train, x_train)
mse.ae2

mse.ae2 <- evaluate(model_Sodra_Delay2, x_test, x_test)
mse.ae2

model_Sodra_Delay2 %>% save_model_hdf5("model_Sodra_Delay2_autocoder.h5")

intermediate_layer_model <- keras_model(inputs = model_Sodra_Delay2$input, outputs = get_layer(model_Sodra_Delay2, "bottleneck")$output)
intermediate_output <- predict(intermediate_layer_model, x_train)
df_train<-as.data.frame(intermediate_output)
df_test<- predict(intermediate_layer_model, x_test)
df_test<-as.data.frame(df_test)
cor(df_train)

names(df_train)<-paste0('Sodra_Delay_', names(df_train))
names(df_test)<-paste0('Sodra_Delay_', names(df_test))

TRAIN_full<-cbind(TRAIN_full, df_train)
TEST_full<-cbind(TEST_full, df_test)

names(TRAIN_full)
############################################################################################
#                       GLM 
############################################################################################

#REG MODEL
reg_model<-glm(TARGET~.,  data=TRAIN_full, family = binomial(link = 'logit'))
reg_model
summary(reg_model)


a_names<-"none"
a_names<-a_names[-1]

start.time<-Sys.time()
for (i in (1:dim(TRAIN_full)[2])){
  print(i)
  a_order<-order(summary(reg_model)$coefficients[,4], decreasing = TRUE)
  a_value<-as.numeric(a_order[1])
  if (a_value==1){
    a_value<-as.numeric(a_order[2])
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(TRAIN_full) %in% a_names))
      reg_model<-glm(TARGET~.,  data=TRAIN_full[,-c(b_names)], family = binomial(link = 'logit'))
    }}
  else{
    bigger<-summary(reg_model)$coefficients[a_value,4] > 0.05
    if (bigger==TRUE) {
      a_names<-append(a_names, names(reg_model$coefficients[a_value]))
      b_names<-as.numeric(which(names(TRAIN_full) %in% a_names))
      reg_model<-glm(TARGET~.,  data=TRAIN_full[,-c(b_names)], family = binomial(link = 'logit'))}
  }
}

summary(reg_model)$coefficients
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken
summary(reg_model)

#PREDICT
pred<-predict(reg_model,TEST_full[,-c(1)])
pred2<-ifelse(pred >= 0.5, 1, 0)
predicted_value <- factor(c(pred2))

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, as.factor(TEST_full$TARGET))
(bin_cm$record_level_cm)

write.csv(cor(TRAIN_full[,-c(1)]), 'C:/Users/Dovile/Desktop/KORAUTO.csv')
