df<-TRAIN_ALL_atr
library(caret)
df<-preProcess(df, method=c("range"))
train_data_u<-predict(df, TRAIN_ALL_atr)
train_data_u[is.na(train_data_u)] = 0
test_data_u<-predict(df, TEST_ALL_atr)
test_data_u[is.na(test_data_u)] = 0



train_data_u2<-train_data_u[,-c(1)]
test_data_u2<-test_data_u[,-c(1)]
########KMEANS
library(ggplot2)
library(factoextra)
library(cluster)


fviz_nbclust(train_data_u2, kmeans, method = "silhouette")


set.seed(123)
km.res <- kmeans(train_data_u2, 2, nstart = 50)

table(km.res$cluster)
prop.table(table(km.res$cluster))

pred<-predict(km.res, test_data[-c(1)])


library(ggplot2)
wssplot <- function(train_data_u2, nc=15, seed=1234){
  wss <- (nrow(train_data_u2)-1)*sum(apply(train_data_u2,2,var))
  for (i in 2:nc){
    set.seed(seed)
    wss[i] <- sum(kmeans(train_data_u2, centers=i)$withinss)}
  plot(1:nc, wss, type="b", xlab="Number of Clusters",
       ylab="Within groups sum of squares")
  wss
}

kmean_withinss <- function(k) {
  cluster <- kmeans(train_data_u2, k)
  return (cluster$tot.withinss)
}

max_k <-20 
# Run algorithm over a range of k 
wss <- sapply(2:max_k, kmean_withinss)

elbow <-data.frame(2:max_k, wss)
ggplot(elbow, aes(x = X2.max_k, y = wss)) +
  geom_point() +
  geom_line() +
  scale_x_continuous(breaks = seq(1, 20, by = 1))

autoplot(km.res, train_data_u2, frame = TRUE)

km.res$centers
km.res$centers[, c("Blogu_stat_docs", "Director_change_quantity")]

points(km.res$centers[, c("Blogu_stat_docs", "Director_change_quantity")], 
       col = 1:3, pch = 8, cex = 3) 

## Visualizing clusters
y_kmeans <- km.res$cluster
clusplot(train_data_u2[, c("Blogu_stat_docs", "Director_change_quantity")],
         y_kmeans,
         lines = 0,
         shade = TRUE,
         color = TRUE,
         labels = 2,
         plotchar = FALSE,
         span = TRUE,
         main = paste("Cluster iris"),
         xlab = 'Blogu_stat_docs',
         ylab = 'Director_change_quantity')


#######################################################

library("flexclust")

cl1 = kcca(train_data_u2, k=2, kccaFamily("kmeans"))
cl1
table(train_data_u$FINAL_STATUS_II)



pred_train <- predict(cl1)
pred <- predict(cl1, newdata=test_data_u2)


predicted_value<-as.data.frame(pred)

table(predicted_value$pred, test_data_u$FINAL_STATUS_II)
prop.table(table(predicted_value$pred, test_data_u$FINAL_STATUS_II),2)
predicted_value$pred_test<-ifelse(predicted_value$pred_test ==1, 0,1)
predicted_value<-as.factor(predicted_value$pred_test)
expected_value<-as.factor(test_data_u$FINAL_STATUS_II)

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

library(isotree)
iso_i <- isolation.forest(as.matrix(train_data_u2))
pred <- predict(iso_i, as.matrix(test_data_u2))
isopredict1 <- as.factor(ifelse(pred > 0.5, 1, 0))
confusionMatrix(isopredict1, expected_value, mode = "everything")

install.packages("outForest")
library(outForest)
set.seed(3)
out_f <- outForest(train_data_u2[,1:5], allow_predictions = TRUE)
plot(out_f)
pred <- predict(out_f, newdata = test_data_u2[,1:5])
boxplot(pred$outliers$predicted)
predicted_value<-(pred$outliers$predicted)
predicted_value<-as.factor(ifelse(predicted_value>0.5,0,1))

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)


#####################one class SVM##############
train_data_one<-subset(train_data_u, FINAL_STATUS_II == 0)
train_data_one<-train_data_one[,-c(1)]

library(e1071)
library(caret)
library(NLP)
library(tm)
library(readr)
library(Hmisc)
svm.model <- svm(train_data_one, y=NULL, type='one-classification', nu=0.10, scale=FALSE, kernel="radial")

pred <- predict(svm.model, test_data_u2)

#####################Ensemble Sparse Partial Least Squares for Outlier Detection##############

library(enpls)
od <- enspls.od(train_data_u2, train_data_u$FINAL_STATUS_II, ratio = 0.8, reptimes = 20, maxcomp = 3)
plot(od, prob = 0.05)
plot(od, criterion = "sd", sdtimes = 2)


pred<-predict(od, test_data_u2)
