#Chi-Square Test 
#In simple words, higher the Chi-Square value the feature is more dependent on the response and it 
#can be selected for model training.

# Null Hypothesis (H0): Two variables are independent.
# Alternate Hypothesis (H1): Two variables are not independent.

chi<-chisq.test(ALL_atr$FINAL_STATUS_II, ALL_atr$Time_after_address_change, correct=FALSE)

chi_stat<-as.numeric(chi$statistic)
chi_df<-as.numeric(chi$parameter)
chi_pvalue<-as.numeric(chi$p.value)
Colum_name<-names(ALL_atr)[6]
chi_target=c(names(ALL_atr)[6], chi_a, chi_b, chi_c)
chi_target<-data.frame(Colum_name, chi_stat, chi_df, chi_pvalue)

b_end<-as.numeric(dim(ALL_atr)[2])
  
for (i in (7:(b_end))){
  print(i)
  chi<-cor.test(ALL_atr[,c(i)], ALL_atr[,c(2)])
  chi_a<-as.numeric(chi$statistic)
  chi_b<-as.numeric(chi$parameter)
  chi_c<-as.numeric(chi$p.value)
  b<-names(ALL_atr)[i]
  new_row = c(b,chi_a, chi_b, chi_c)
  chi_target<-rbind(chi_target, new_row)
}

chi_target$chi_pvalue_if<-ifelse(chi_target$chi_pvalue>0.05,1,0)
table(chi_target$chi_pvalue_if, useNA = 'always')


t.test(ALL_atr$FINAL_STATUS_II, ALL_atr$Time_after_address_change, paired=TRUE)
t.test(ALL_atr$FINAL_STATUS_II, ALL_atr$Time_after_address_change, paired=FALSE)
#ANOVA test
#Note: When you have only 2-groups, you can also use a t-test. However empirically the p-value of t-test and ANOVA often line up.
#Unequal Variance T-Test
#https://www.investopedia.com/terms/t/t-test.asp#:~:text=A%20large%20t%2Dscore%2C%20or,validity%20of%20the%20null%20hypothesis.
#this test is also called Welch's t-test.

#Kruskal-Wallis test
#https://towardsdatascience.com/every-statistical-test-to-check-feature-dependence-773a21cd6722

t.test(ALL_atr[which(ALL_atr$FINAL_STATUS_II==0), 'Time_after_address_change'], ALL_atr[which(ALL_atr$FINAL_STATUS_II==1), 'Time_after_address_change'], paired=FALSE)
#install.packages('rstatix')
library(rstatix)
cohens_d(ALL_atr[which(ALL_atr$FINAL_STATUS_II==0), 'Time_after_address_change'], ALL_atr[which(ALL_atr$FINAL_STATUS_II==1), 'Time_after_address_change'], var.equal = FALSE)
cohens_d(ALL_atr, Time_after_address_change~FINAL_STATUS_II, paired = FALSE, var.equal = FALSE)

cohens_d_target<-cohens_d(ALL_atr, Time_after_address_change~FINAL_STATUS_II, paired = FALSE, var.equal = FALSE)
cohens_d_target<-cohens_d(ALL_atr, cat(names(ALL_atr)[7], '\n')~FINAL_STATUS_II, paired = FALSE, var.equal = FALSE)
cat(names(ALL_atr)[6], '\n')
A<-lapply(ALL_atr[c(6,7)],function(x) cohens_d(ALL_atr, (x ~ FINAL_STATUS_II), paired = FALSE, var.equal = FALSE))
cohens_d(ALL_atr, ALL_atr[,7]~ALL_atr[,2], paired = FALSE, var.equal = FALSE)

paste(colnames(df)[5])
cohens_d(ALL_atr, Time_after_address_change~FINAL_STATUS_II, paired = FALSE, var.equal = FALSE)
#cohens_d(ALL_atr, paste(colnames(ALL_atr)[7])~FINAL_STATUS_II, paired = FALSE, var.equal = FALSE)

for(i in colnames(ALL_atr[8:10])){
  print(i)
  cohens_d_info<-cohens_d(ALL_atr, i~FINAL_STATUS_II, paired = FALSE, var.equal = FALSE)
  cohens_d_target<-rbind(cohens_d_target, cohens_d_info)
}

d <- 5
for(i in 1:10) { 
  nam <- paste("A", i, sep = "")
  assign(nam, rnorm(3)+d)
}

#####
library(rstatix)
stulpeliu_vardai<-colnames(ALL_atr)
cohens_d_target<-cohens_d(ALL_atr, Address_change_quantity~FINAL_STATUS_II, paired = FALSE, var.equal = FALSE)
b_end<-as.numeric(dim(ALL_atr)[2])

for (i in (7:(b_end))){
  print(i)
  colnames(ALL_atr)[i]<-'x'
  cohens_d_info<-cohens_d(ALL_atr, x~FINAL_STATUS_II, paired = FALSE, var.equal = FALSE)
  colnames(ALL_atr)[i]<-stulpeliu_vardai[i]
  cohens_d_target<-rbind(cohens_d_target, cohens_d_info)
  cohens_d_target[(i-5),1]<-stulpeliu_vardai[i]
}
#ii budas
for (i in (7:(b_end))){
  print(i)
  form <- as.formula(paste(colnames(ALL_atr)[i], "~FINAL_STATUS_II"))
  cohens_d_info <- cohens_d(ALL_atr, form, paired = FALSE, var.equal = FALSE)
  cohens_d_target<-rbind(cohens_d_target, cohens_d_info)
}

setwd('F:/2022 11 09 STRATEGY II')
table(cohens_d_target$magnitude, useNA = 'always')

#STRATEGIJA B tik su large and moderate, kita ir su small
a_group<-c('small', 'negligible')
a_names<-cohens_d_target[which(cohens_d_target$magnitude %in% a_group), 1]
a_names<-a_names$.y.

ALL_atr_ch_D_strong<-ALL_atr[,which(!colnames(ALL_atr) %in% a_names)]

a_group<-c('negligible')
a_names<-cohens_d_target[which(cohens_d_target$magnitude %in% a_group), 1]
a_names<-a_names$.y.

ALL_atr_ch_D<-ALL_atr[,which(!colnames(ALL_atr) %in% a_names)]


ST_B_I<-ALL_atr_ch_D_strong[,-c(1,4,5)]
df<-ST_B_I
library(caret)
df<-preProcess(df, method=c("range"))
df2<-predict(df, ST_B_I)
ST_B_I<-df2
ST_B_I[is.na(ST_B_I)] = 0

ST_B_II<-ALL_atr_ch_D[,-c(1,4,5)]
df<-ST_B_II
library(caret)
df<-preProcess(df, method=c("range"))
df2<-predict(df, ST_B_II)
ST_B_II<-df2
ST_B_II[is.na(ST_B_II)] = 0

#############################################################################