#########################################################################################################################
#                                                               ADA Boost
#########################################################################################################################
library(tidyverse)
library(caret)
library(adabag)

#ada_model<-train(TARGET~., method='AdaBoost.M1', data= train_data )
start.time<-Sys.time()
ada_model<-boosting(TARGET~., data=train_data, boos=TRUE, mfinal=50)
end.time<-Sys.time()
time.taken<-round(end.time-start.time, 2)
time.taken


pred = predict(ada_model, test_data)
predicted_value <- factor(c(pred$class))
Predicted_values$Ada_boost<-predicted_value
library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"Adaboost"
Palyginimo<-rbind(Palyginimo, New_row_pal)


############################################
start.time2<-Sys.time()
## SVM-Polynomial

library(e1071)
library(caret)
library(NLP)
library(tm)
library(readr)
library(Hmisc)
poly.svmfit=svm(TARGET~.,data=train_data_num,kernel="polynomial")
predicted_value=predict(poly.svmfit,test_data_num[,-c(1)])
pred<-predicted_value
predicted_value<-as.data.frame(pred)
predicted_value<-as.factor(predicted_value$pred)
Predicted_values$SVM_poly<-predicted_value

end.time2<-Sys.time()
time.taken2<-round(end.time2-start.time2, 2)
time.taken2

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"SVM polynomial"

Palyginimo<-rbind(Palyginimo, New_row_pal) 

library(e1071)
start.time3<-Sys.time()
radial.svmfit=svm(TARGET~.,data=train_data_num,kernel="radial")
predicted_value2=predict(radial.svmfit,test_data_num[,-c(1)])
#Predicted_values$SVM_radial<-predicted_value

predicted_value<-as.data.frame(predicted_value2)
predicted_value<-as.factor(predicted_value$predicted_value2)
Predicted_values$SVM_radial<-predicted_value

end.time3<-Sys.time()
time.taken3<-round(end.time3-start.time3, 2)
time.taken3

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)

New_row_pal<-as.data.frame(bin_cm$record_level_cm)

a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
library(dgof)
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"SVM radial"
Palyginimo<-rbind(Palyginimo, New_row_pal) 

#########################################################################################################################
#                                                ONE CLASS SVM
#########################################################################################################################
start.time4<-Sys.time()

train_data_one<-subset(train_data_u, TARGET == 0)
train_data_one<-train_data_one[,-c(1)]

library(e1071)
library(caret)
library(NLP)
library(tm)
library(readr)
library(Hmisc)
svm.model <- svm(train_data_one, y=NULL, type='one-classification', nu=0.10, scale=FALSE, kernel="radial")

pred <- predict(svm.model, test_data_u2)
table(pred)
predicted_value <- as.factor(ifelse(pred == 'TRUE', 0, 1))
Predicted_values$One_svm<-predicted_value

library('ConfusionTableR')
bin_cm <- ConfusionTableR::binary_class_cm(predicted_value, expected_value)
(bin_cm$record_level_cm)
New_row_pal<-as.data.frame(bin_cm$record_level_cm)
a<-names(New_row_pal)
a<-a[c(1:6,12,13,16,17,18,22)]
New_row_pal<-New_row_pal[,which(names(New_row_pal) %in% a)]
New_row_pal$AUC<-MLmetrics::AUC(predicted_value, expected_value) #nezinau bet su 1 gerai skaiciuoja su 0 blogai
New_row_pal$K_S<-as.numeric(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$statistic)
New_row_pal$K_S_pvalue<-(ks.test(as.numeric(predicted_value), as.numeric(expected_value))$p.value)
New_row_pal$Error_rate<-1-New_row_pal$Accuracy
New_row_pal$Type_I_err<-New_row_pal$Pred_0_Ref_1/(New_row_pal$Pred_0_Ref_1+New_row_pal$Pred_1_Ref_1)
New_row_pal$Type_II_err<-New_row_pal$Pred_1_Ref_0/(New_row_pal$Pred_1_Ref_0+New_row_pal$Pred_0_Ref_0)
New_row_pal$MCC<-((New_row_pal$Pred_0_Ref_0*New_row_pal$Pred_1_Ref_1)-(New_row_pal$Pred_1_Ref_0*New_row_pal$Pred_0_Ref_1))/
  sqrt(as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_1_Ref_0)*as.numeric(New_row_pal$Pred_0_Ref_0+New_row_pal$Pred_0_Ref_1)*as.numeric(New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_1_Ref_0)*as.numeric((New_row_pal$Pred_1_Ref_1+New_row_pal$Pred_0_Ref_1)))
New_row_pal$G_mean<-sqrt(as.numeric(New_row_pal$Recall)*as.numeric(New_row_pal$Specificity))
#GINI=2*AUC-1    https://towardsdatascience.com/using-the-gini-coefficient-to-evaluate-the-performance-of-credit-score-models-59fe13ef420
New_row_pal$Gini<-2*New_row_pal$AUC-1
New_row_pal$Modelis<-"One SVM"
Palyginimo<-rbind(Palyginimo, New_row_pal)
end.time4<-Sys.time()
time.taken4<-round(end.time4-start.time4, 2)
time.taken4
